gi-gtk-3.0.43: Gtk bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Gtk.Structs.TextIter

Contents

- Exported types
- Methods
  - assign
  - backwardChar
  - backwardChars
  - backwardCursorPosition
  - backwardCursorPositions
  - backwardFindChar
  - backwardLine
  - backwardLines
  - backwardSearch
  - backwardSentenceStart
  - backwardSentenceStarts
  - backwardToTagToggle
  - backwardVisibleCursorPosition
  - backwardVisibleCursorPositions
  - backwardVisibleLine
  - backwardVisibleLines
  - backwardVisibleWordStart
  - backwardVisibleWordStarts
  - backwardWordStart
  - backwardWordStarts
  - beginsTag
  - canInsert
  - compare
  - copy
  - editable
  - endsLine
  - endsSentence
  - endsTag
  - endsWord
  - equal
  - forwardChar
  - forwardChars
  - forwardCursorPosition
  - forwardCursorPositions
  - forwardFindChar
  - forwardLine
  - forwardLines
  - forwardSearch
  - forwardSentenceEnd
  - forwardSentenceEnds
  - forwardToEnd
  - forwardToLineEnd
  - forwardToTagToggle
  - forwardVisibleCursorPosition
  - forwardVisibleCursorPositions
  - forwardVisibleLine
  - forwardVisibleLines
  - forwardVisibleWordEnd
  - forwardVisibleWordEnds
  - forwardWordEnd
  - forwardWordEnds
  - free
  - getAttributes
  - getBuffer
  - getBytesInLine
  - getChar
  - getCharsInLine
  - getChildAnchor
  - getLanguage
  - getLine
  - getLineIndex
  - getLineOffset
  - getMarks
  - getOffset
  - getPixbuf
  - getSlice
  - getTags
  - getText
  - getToggledTags
  - getVisibleLineIndex
  - getVisibleLineOffset
  - getVisibleSlice
  - getVisibleText
  - hasTag
  - inRange
  - insideSentence
  - insideWord
  - isCursorPosition
  - isEnd
  - isStart
  - order
  - setLine
  - setLineIndex
  - setLineOffset
  - setOffset
  - setVisibleLineIndex
  - setVisibleLineOffset
  - startsLine
  - startsSentence
  - startsTag
  - startsWord
  - togglesTag

Description

You may wish to begin by reading the text widget conceptual overview which gives an overview of all the objects and data types related to the text widget and how they work together.

Synopsis

- newtype TextIter = TextIter (ManagedPtr TextIter)
- newZeroTextIter :: MonadIO m => m TextIter
- textIterAssign :: (HasCallStack, MonadIO m) => TextIter -> TextIter -> m ()
- textIterBackwardChar :: (HasCallStack, MonadIO m) => TextIter -> m Bool
- textIterBackwardChars :: (HasCallStack, MonadIO m) => TextIter -> Int32 -> m Bool
- textIterBackwardCursorPosition :: (HasCallStack, MonadIO m) => TextIter -> m Bool
- textIterBackwardCursorPositions :: (HasCallStack, MonadIO m) => TextIter -> Int32 -> m Bool
- textIterBackwardFindChar :: (HasCallStack, MonadIO m) => TextIter -> TextCharPredicate -> Maybe TextIter -> m Bool
- textIterBackwardLine :: (HasCallStack, MonadIO m) => TextIter -> m Bool
- textIterBackwardLines :: (HasCallStack, MonadIO m) => TextIter -> Int32 -> m Bool
- textIterBackwardSearch :: (HasCallStack, MonadIO m) => TextIter -> Text -> [TextSearchFlags] -> Maybe TextIter -> m (Bool, TextIter, TextIter)
- textIterBackwardSentenceStart :: (HasCallStack, MonadIO m) => TextIter -> m Bool
- textIterBackwardSentenceStarts :: (HasCallStack, MonadIO m) => TextIter -> Int32 -> m Bool
- textIterBackwardToTagToggle :: (HasCallStack, MonadIO m, IsTextTag a) => TextIter -> Maybe a -> m Bool
- textIterBackwardVisibleCursorPosition :: (HasCallStack, MonadIO m) => TextIter -> m Bool
- textIterBackwardVisibleCursorPositions :: (HasCallStack, MonadIO m) => TextIter -> Int32 -> m Bool
- textIterBackwardVisibleLine :: (HasCallStack, MonadIO m) => TextIter -> m Bool
- textIterBackwardVisibleLines :: (HasCallStack, MonadIO m) => TextIter -> Int32 -> m Bool
- textIterBackwardVisibleWordStart :: (HasCallStack, MonadIO m) => TextIter -> m Bool
- textIterBackwardVisibleWordStarts :: (HasCallStack, MonadIO m) => TextIter -> Int32 -> m Bool
- textIterBackwardWordStart :: (HasCallStack, MonadIO m) => TextIter -> m Bool
- textIterBackwardWordStarts :: (HasCallStack, MonadIO m) => TextIter -> Int32 -> m Bool
- textIterBeginsTag :: (HasCallStack, MonadIO m, IsTextTag a) => TextIter -> Maybe a -> m Bool
- textIterCanInsert :: (HasCallStack, MonadIO m) => TextIter -> Bool -> m Bool
- textIterCompare :: (HasCallStack, MonadIO m) => TextIter -> TextIter -> m Int32
- textIterCopy :: (HasCallStack, MonadIO m) => TextIter -> m TextIter
- textIterEditable :: (HasCallStack, MonadIO m) => TextIter -> Bool -> m Bool
- textIterEndsLine :: (HasCallStack, MonadIO m) => TextIter -> m Bool
- textIterEndsSentence :: (HasCallStack, MonadIO m) => TextIter -> m Bool
- textIterEndsTag :: (HasCallStack, MonadIO m, IsTextTag a) => TextIter -> Maybe a -> m Bool
- textIterEndsWord :: (HasCallStack, MonadIO m) => TextIter -> m Bool
- textIterEqual :: (HasCallStack, MonadIO m) => TextIter -> TextIter -> m Bool
- textIterForwardChar :: (HasCallStack, MonadIO m) => TextIter -> m Bool
- textIterForwardChars :: (HasCallStack, MonadIO m) => TextIter -> Int32 -> m Bool
- textIterForwardCursorPosition :: (HasCallStack, MonadIO m) => TextIter -> m Bool
- textIterForwardCursorPositions :: (HasCallStack, MonadIO m) => TextIter -> Int32 -> m Bool
- textIterForwardFindChar :: (HasCallStack, MonadIO m) => TextIter -> TextCharPredicate -> Maybe TextIter -> m Bool
- textIterForwardLine :: (HasCallStack, MonadIO m) => TextIter -> m Bool
- textIterForwardLines :: (HasCallStack, MonadIO m) => TextIter -> Int32 -> m Bool
- textIterForwardSearch :: (HasCallStack, MonadIO m) => TextIter -> Text -> [TextSearchFlags] -> Maybe TextIter -> m (Bool, TextIter, TextIter)
- textIterForwardSentenceEnd :: (HasCallStack, MonadIO m) => TextIter -> m Bool
- textIterForwardSentenceEnds :: (HasCallStack, MonadIO m) => TextIter -> Int32 -> m Bool
- textIterForwardToEnd :: (HasCallStack, MonadIO m) => TextIter -> m ()
- textIterForwardToLineEnd :: (HasCallStack, MonadIO m) => TextIter -> m Bool
- textIterForwardToTagToggle :: (HasCallStack, MonadIO m, IsTextTag a) => TextIter -> Maybe a -> m Bool
- textIterForwardVisibleCursorPosition :: (HasCallStack, MonadIO m) => TextIter -> m Bool
- textIterForwardVisibleCursorPositions :: (HasCallStack, MonadIO m) => TextIter -> Int32 -> m Bool
- textIterForwardVisibleLine :: (HasCallStack, MonadIO m) => TextIter -> m Bool
- textIterForwardVisibleLines :: (HasCallStack, MonadIO m) => TextIter -> Int32 -> m Bool
- textIterForwardVisibleWordEnd :: (HasCallStack, MonadIO m) => TextIter -> m Bool
- textIterForwardVisibleWordEnds :: (HasCallStack, MonadIO m) => TextIter -> Int32 -> m Bool
- textIterForwardWordEnd :: (HasCallStack, MonadIO m) => TextIter -> m Bool
- textIterForwardWordEnds :: (HasCallStack, MonadIO m) => TextIter -> Int32 -> m Bool
- textIterFree :: (HasCallStack, MonadIO m) => TextIter -> m ()
- textIterGetAttributes :: (HasCallStack, MonadIO m) => TextIter -> m (Bool, TextAttributes)
- textIterGetBuffer :: (HasCallStack, MonadIO m) => TextIter -> m TextBuffer
- textIterGetBytesInLine :: (HasCallStack, MonadIO m) => TextIter -> m Int32
- textIterGetChar :: (HasCallStack, MonadIO m) => TextIter -> m Char
- textIterGetCharsInLine :: (HasCallStack, MonadIO m) => TextIter -> m Int32
- textIterGetChildAnchor :: (HasCallStack, MonadIO m) => TextIter -> m TextChildAnchor
- textIterGetLanguage :: (HasCallStack, MonadIO m) => TextIter -> m Language
- textIterGetLine :: (HasCallStack, MonadIO m) => TextIter -> m Int32
- textIterGetLineIndex :: (HasCallStack, MonadIO m) => TextIter -> m Int32
- textIterGetLineOffset :: (HasCallStack, MonadIO m) => TextIter -> m Int32
- textIterGetMarks :: (HasCallStack, MonadIO m) => TextIter -> m [TextMark]
- textIterGetOffset :: (HasCallStack, MonadIO m) => TextIter -> m Int32
- textIterGetPixbuf :: (HasCallStack, MonadIO m) => TextIter -> m Pixbuf
- textIterGetSlice :: (HasCallStack, MonadIO m) => TextIter -> TextIter -> m Text
- textIterGetTags :: (HasCallStack, MonadIO m) => TextIter -> m [TextTag]
- textIterGetText :: (HasCallStack, MonadIO m) => TextIter -> TextIter -> m Text
- textIterGetToggledTags :: (HasCallStack, MonadIO m) => TextIter -> Bool -> m [TextTag]
- textIterGetVisibleLineIndex :: (HasCallStack, MonadIO m) => TextIter -> m Int32
- textIterGetVisibleLineOffset :: (HasCallStack, MonadIO m) => TextIter -> m Int32
- textIterGetVisibleSlice :: (HasCallStack, MonadIO m) => TextIter -> TextIter -> m Text
- textIterGetVisibleText :: (HasCallStack, MonadIO m) => TextIter -> TextIter -> m Text
- textIterHasTag :: (HasCallStack, MonadIO m, IsTextTag a) => TextIter -> a -> m Bool
- textIterInRange :: (HasCallStack, MonadIO m) => TextIter -> TextIter -> TextIter -> m Bool
- textIterInsideSentence :: (HasCallStack, MonadIO m) => TextIter -> m Bool
- textIterInsideWord :: (HasCallStack, MonadIO m) => TextIter -> m Bool
- textIterIsCursorPosition :: (HasCallStack, MonadIO m) => TextIter -> m Bool
- textIterIsEnd :: (HasCallStack, MonadIO m) => TextIter -> m Bool
- textIterIsStart :: (HasCallStack, MonadIO m) => TextIter -> m Bool
- textIterOrder :: (HasCallStack, MonadIO m) => TextIter -> TextIter -> m ()
- textIterSetLine :: (HasCallStack, MonadIO m) => TextIter -> Int32 -> m ()
- textIterSetLineIndex :: (HasCallStack, MonadIO m) => TextIter -> Int32 -> m ()
- textIterSetLineOffset :: (HasCallStack, MonadIO m) => TextIter -> Int32 -> m ()
- textIterSetOffset :: (HasCallStack, MonadIO m) => TextIter -> Int32 -> m ()
- textIterSetVisibleLineIndex :: (HasCallStack, MonadIO m) => TextIter -> Int32 -> m ()
- textIterSetVisibleLineOffset :: (HasCallStack, MonadIO m) => TextIter -> Int32 -> m ()
- textIterStartsLine :: (HasCallStack, MonadIO m) => TextIter -> m Bool
- textIterStartsSentence :: (HasCallStack, MonadIO m) => TextIter -> m Bool
- textIterStartsTag :: (HasCallStack, MonadIO m, IsTextTag a) => TextIter -> Maybe a -> m Bool
- textIterStartsWord :: (HasCallStack, MonadIO m) => TextIter -> m Bool
- textIterTogglesTag :: (HasCallStack, MonadIO m, IsTextTag a) => TextIter -> Maybe a -> m Bool

# Exported types

newtype TextIter Source #

Memory-managed wrapper type.

Constructors

TextIter (ManagedPtr TextIter) |

#### Instances

Instances details

Eq TextIter Source # |
Instance details Defined in GI.Gtk.Structs.TextIter Methods (==) :: TextIter -> TextIter -> Bool Source # (/=) :: TextIter -> TextIter -> Bool Source #
GBoxed TextIter Source # |
Instance details Defined in GI.Gtk.Structs.TextIter
ManagedPtrNewtype TextIter Source # |
Instance details Defined in GI.Gtk.Structs.TextIter Methods toManagedPtr :: TextIter -> ManagedPtr TextIter Source #
TypedObject TextIter Source # |
Instance details Defined in GI.Gtk.Structs.TextIter Methods glibType :: IO GType Source #
HasParentTypes TextIter Source # |
Instance details Defined in GI.Gtk.Structs.TextIter
tag ~ 'AttrSet => Constructible TextIter tag Source # |
Instance details Defined in GI.Gtk.Structs.TextIter Methods new :: MonadIO m => (ManagedPtr TextIter -> TextIter) -> [AttrOp TextIter tag] -> m TextIter Source #
IsGValue (Maybe TextIter) Source # | Convert `TextIter` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.Gtk.Structs.TextIter Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe TextIter -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe TextIter) Source #
type ParentTypes TextIter Source # |
Instance details Defined in GI.Gtk.Structs.TextIter type ParentTypes TextIter = '[] :: [Type]

newZeroTextIter :: MonadIO m => m TextIter Source #

Construct a `TextIter` struct initialized to zero.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

assign, backwardChar, backwardChars, backwardCursorPosition, backwardCursorPositions, backwardFindChar, backwardLine, backwardLines, backwardSearch, backwardSentenceStart, backwardSentenceStarts, backwardToTagToggle, backwardVisibleCursorPosition, backwardVisibleCursorPositions, backwardVisibleLine, backwardVisibleLines, backwardVisibleWordStart, backwardVisibleWordStarts, backwardWordStart, backwardWordStarts, beginsTag, canInsert, compare, copy, editable, endsLine, endsSentence, endsTag, endsWord, equal, forwardChar, forwardChars, forwardCursorPosition, forwardCursorPositions, forwardFindChar, forwardLine, forwardLines, forwardSearch, forwardSentenceEnd, forwardSentenceEnds, forwardToEnd, forwardToLineEnd, forwardToTagToggle, forwardVisibleCursorPosition, forwardVisibleCursorPositions, forwardVisibleLine, forwardVisibleLines, forwardVisibleWordEnd, forwardVisibleWordEnds, forwardWordEnd, forwardWordEnds, free, hasTag, inRange, insideSentence, insideWord, isCursorPosition, isEnd, isStart, order, startsLine, startsSentence, startsTag, startsWord, togglesTag.

#### Getters

getAttributes, getBuffer, getBytesInLine, getChar, getCharsInLine, getChildAnchor, getLanguage, getLine, getLineIndex, getLineOffset, getMarks, getOffset, getPixbuf, getSlice, getTags, getText, getToggledTags, getVisibleLineIndex, getVisibleLineOffset, getVisibleSlice, getVisibleText.

#### Setters

setLine, setLineIndex, setLineOffset, setOffset, setVisibleLineIndex, setVisibleLineOffset.

## assign

textIterAssign Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> TextIter | `other`: another `TextIter`
-> m () |

Assigns the value of `other` to `iter`. This function is not useful in applications, because iterators can be assigned with `GtkTextIter i = j;`. The function is used by language bindings.

Since: 3.2

## backwardChar

textIterBackwardChar Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> m Bool | Returns: whether movement was possible

Moves backward by one character offset. Returns `True` if movement was possible; if `iter` was the first in the buffer (character offset 0), `textIterBackwardChar` returns `False` for convenience when writing loops.

## backwardChars

textIterBackwardChars Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> Int32 | `count`: number of characters to move
-> m Bool | Returns: whether `iter` moved and is dereferenceable

Moves `count` characters backward, if possible (if `count` would move past the start or end of the buffer, moves to the start or end of the buffer). The return value indicates whether the iterator moved onto a dereferenceable position; if the iterator didn’t move, or moved onto the end iterator, then `False` is returned. If `count` is 0, the function does nothing and returns `False`.

## backwardCursorPosition

textIterBackwardCursorPosition Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> m Bool | Returns: `True` if we moved

Like `textIterForwardCursorPosition`, but moves backward.

## backwardCursorPositions

textIterBackwardCursorPositions Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> Int32 | `count`: number of positions to move
-> m Bool | Returns: `True` if we moved and the new position is dereferenceable

Moves up to `count` cursor positions. See `textIterForwardCursorPosition` for details.

## backwardFindChar

textIterBackwardFindChar Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> TextCharPredicate | `pred`: function to be called on each character
-> Maybe TextIter | `limit`: search limit, or `Nothing` for none
-> m Bool | Returns: whether a match was found

Same as `textIterForwardFindChar`, but goes backward from `iter`.

## backwardLine

textIterBackwardLine Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> m Bool | Returns: whether `iter` moved

Moves `iter` to the start of the previous line. Returns `True` if `iter` could be moved; i.e. if `iter` was at character offset 0, this function returns `False`. Therefore if `iter` was already on line 0, but not at the start of the line, `iter` is snapped to the start of the line and the function returns `True`. (Note that this implies that in a loop calling this function, the line number may not change on every iteration, if your first iteration is on line 0.)

## backwardLines

textIterBackwardLines Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> Int32 | `count`: number of lines to move backward
-> m Bool | Returns: whether `iter` moved and is dereferenceable

Moves `count` lines backward, if possible (if `count` would move past the start or end of the buffer, moves to the start or end of the buffer). The return value indicates whether the iterator moved onto a dereferenceable position; if the iterator didn’t move, or moved onto the end iterator, then `False` is returned. If `count` is 0, the function does nothing and returns `False`. If `count` is negative, moves forward by 0 - `count` lines.

## backwardSearch

textIterBackwardSearch Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter` where the search begins
-> Text | `str`: search string
-> [TextSearchFlags] | `flags`: bitmask of flags affecting the search
-> Maybe TextIter | `limit`: location of last possible `matchStart`, or `Nothing` for start of buffer
-> m (Bool, TextIter, TextIter) | Returns: whether a match was found

Same as `textIterForwardSearch`, but moves backward.

`matchEnd` will never be set to a `TextIter` located after `iter`, even if there is a possible `matchStart` before or at `iter`.

## backwardSentenceStart

textIterBackwardSentenceStart Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> m Bool | Returns: `True` if `iter` moved and is not the end iterator

Moves backward to the previous sentence start; if `iter` is already at the start of a sentence, moves backward to the next one. Sentence boundaries are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango text boundary algorithms).

## backwardSentenceStarts

textIterBackwardSentenceStarts Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> Int32 | `count`: number of sentences to move
-> m Bool | Returns: `True` if `iter` moved and is not the end iterator

Calls `textIterBackwardSentenceStart` up to `count` times, or until it returns `False`. If `count` is negative, moves forward instead of backward.

## backwardToTagToggle

textIterBackwardToTagToggle Source #

Arguments

:: (HasCallStack, MonadIO m, IsTextTag a) |
=> TextIter | `iter`: a `TextIter`
-> Maybe a | `tag`: a `TextTag`, or `Nothing`
-> m Bool | Returns: whether we found a tag toggle before `iter`

Moves backward to the next toggle (on or off) of the `TextTag` `tag`, or to the next toggle of any tag if `tag` is `Nothing`. If no matching tag toggles are found, returns `False`, otherwise `True`. Does not return toggles located at `iter`, only toggles before `iter`. Sets `iter` to the location of the toggle, or the start of the buffer if no toggle is found.

## backwardVisibleCursorPosition

textIterBackwardVisibleCursorPosition Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> m Bool | Returns: `True` if we moved and the new position is dereferenceable

Moves `iter` forward to the previous visible cursor position. See `textIterBackwardCursorPosition` for details.

Since: 2.4

## backwardVisibleCursorPositions

textIterBackwardVisibleCursorPositions Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> Int32 | `count`: number of positions to move
-> m Bool | Returns: `True` if we moved and the new position is dereferenceable

Moves up to `count` visible cursor positions. See `textIterBackwardCursorPosition` for details.

Since: 2.4

## backwardVisibleLine

textIterBackwardVisibleLine Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> m Bool | Returns: whether `iter` moved

Moves `iter` to the start of the previous visible line. Returns `True` if `iter` could be moved; i.e. if `iter` was at character offset 0, this function returns `False`. Therefore if `iter` was already on line 0, but not at the start of the line, `iter` is snapped to the start of the line and the function returns `True`. (Note that this implies that in a loop calling this function, the line number may not change on every iteration, if your first iteration is on line 0.)

Since: 2.8

## backwardVisibleLines

textIterBackwardVisibleLines Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> Int32 | `count`: number of lines to move backward
-> m Bool | Returns: whether `iter` moved and is dereferenceable

Moves `count` visible lines backward, if possible (if `count` would move past the start or end of the buffer, moves to the start or end of the buffer). The return value indicates whether the iterator moved onto a dereferenceable position; if the iterator didn’t move, or moved onto the end iterator, then `False` is returned. If `count` is 0, the function does nothing and returns `False`. If `count` is negative, moves forward by 0 - `count` lines.

Since: 2.8

## backwardVisibleWordStart

textIterBackwardVisibleWordStart Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> m Bool | Returns: `True` if `iter` moved and is not the end iterator

Moves backward to the previous visible word start. (If `iter` is currently on a word start, moves backward to the next one after that.) Word breaks are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango word break algorithms).

Since: 2.4

## backwardVisibleWordStarts

textIterBackwardVisibleWordStarts Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> Int32 | `count`: number of times to move
-> m Bool | Returns: `True` if `iter` moved and is not the end iterator

Calls `textIterBackwardVisibleWordStart` up to `count` times.

Since: 2.4

## backwardWordStart

textIterBackwardWordStart Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> m Bool | Returns: `True` if `iter` moved and is not the end iterator

Moves backward to the previous word start. (If `iter` is currently on a word start, moves backward to the next one after that.) Word breaks are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango word break algorithms).

## backwardWordStarts

textIterBackwardWordStarts Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> Int32 | `count`: number of times to move
-> m Bool | Returns: `True` if `iter` moved and is not the end iterator

Calls `textIterBackwardWordStart` up to `count` times.

## beginsTag

textIterBeginsTag Source #

Arguments

:: (HasCallStack, MonadIO m, IsTextTag a) |
=> TextIter | `iter`: an iterator
-> Maybe a | `tag`: a `TextTag`, or `Nothing`
-> m Bool | Returns: whether `iter` is the start of a range tagged with `tag`

Deprecated: (Since version 3.20)Use `textIterStartsTag` instead.

Returns `True` if `tag` is toggled on at exactly this point. If `tag` is `Nothing`, returns `True` if any tag is toggled on at this point.

Note that if `textIterBeginsTag` returns `True`, it means that `iter` is at the beginning of the tagged range, and that the character at `iter` is inside the tagged range. In other words, unlike `textIterEndsTag`, if `textIterBeginsTag` returns `True`, `textIterHasTag` will also return `True` for the same parameters.

## canInsert

textIterCanInsert Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> Bool | `defaultEditability`: `True` if text is editable by default
-> m Bool | Returns: whether text inserted at `iter` would be editable

Considering the default editability of the buffer, and tags that affect editability, determines whether text inserted at `iter` would be editable. If text inserted at `iter` would be editable then the user should be allowed to insert text at `iter`. `textBufferInsertInteractive` uses this function to decide whether insertions are allowed at a given position.

## compare

textIterCompare Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `lhs`: a `TextIter`
-> TextIter | `rhs`: another `TextIter`
-> m Int32 | Returns: -1 if `lhs` is less than `rhs`, 1 if `lhs` is greater, 0 if they are equal

A `qsort()`-style function that returns negative if `lhs` is less than `rhs`, positive if `lhs` is greater than `rhs`, and 0 if they’re equal. Ordering is in character offset order, i.e. the first character in the buffer is less than the second character in the buffer.

## copy

textIterCopy Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> m TextIter | Returns: a copy of the `iter`, free with `textIterFree`

Creates a dynamically-allocated copy of an iterator. This function is not useful in applications, because iterators can be copied with a simple assignment (`GtkTextIter i = j;`). The function is used by language bindings.

## editable

textIterEditable Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> Bool | `defaultSetting`: `True` if text is editable by default
-> m Bool | Returns: whether `iter` is inside an editable range

Returns whether the character at `iter` is within an editable region of text. Non-editable text is “locked” and can’t be changed by the user via `TextView`. This function is simply a convenience wrapper around `textIterGetAttributes`. If no tags applied to this text affect editability, `defaultSetting` will be returned.

You don’t want to use this function to decide whether text can be inserted at `iter`, because for insertion you don’t want to know whether the char at `iter` is inside an editable range, you want to know whether a new character inserted at `iter` would be inside an editable range. Use `textIterCanInsert` to handle this case.

## endsLine

textIterEndsLine Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> m Bool | Returns: whether `iter` is at the end of a line

Returns `True` if `iter` points to the start of the paragraph delimiter characters for a line (delimiters will be either a newline, a carriage return, a carriage return followed by a newline, or a Unicode paragraph separator character). Note that an iterator pointing to the \n of a \r\n pair will not be counted as the end of a line, the line ends before the \r. The end iterator is considered to be at the end of a line, even though there are no paragraph delimiter chars there.

## endsSentence

textIterEndsSentence Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> m Bool | Returns: `True` if `iter` is at the end of a sentence.

Determines whether `iter` ends a sentence. Sentence boundaries are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango text boundary algorithms).

## endsTag

textIterEndsTag Source #

Arguments

:: (HasCallStack, MonadIO m, IsTextTag a) |
=> TextIter | `iter`: an iterator
-> Maybe a | `tag`: a `TextTag`, or `Nothing`
-> m Bool | Returns: whether `iter` is the end of a range tagged with `tag`

Returns `True` if `tag` is toggled off at exactly this point. If `tag` is `Nothing`, returns `True` if any tag is toggled off at this point.

Note that if `textIterEndsTag` returns `True`, it means that `iter` is at the end of the tagged range, but that the character at `iter` is outside the tagged range. In other words, unlike `textIterStartsTag`, if `textIterEndsTag` returns `True`, `textIterHasTag` will return `False` for the same parameters.

## endsWord

textIterEndsWord Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> m Bool | Returns: `True` if `iter` is at the end of a word

Determines whether `iter` ends a natural-language word. Word breaks are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango word break algorithms).

## equal

textIterEqual Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `lhs`: a `TextIter`
-> TextIter | `rhs`: another `TextIter`
-> m Bool | Returns: `True` if the iterators point to the same place in the buffer

Tests whether two iterators are equal, using the fastest possible mechanism. This function is very fast; you can expect it to perform better than e.g. getting the character offset for each iterator and comparing the offsets yourself. Also, it’s a bit faster than `textIterCompare`.

## forwardChar

textIterForwardChar Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> m Bool | Returns: whether `iter` moved and is dereferenceable

Moves `iter` forward by one character offset. Note that images embedded in the buffer occupy 1 character slot, so `textIterForwardChar` may actually move onto an image instead of a character, if you have images in your buffer. If `iter` is the end iterator or one character before it, `iter` will now point at the end iterator, and `textIterForwardChar` returns `False` for convenience when writing loops.

## forwardChars

textIterForwardChars Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> Int32 | `count`: number of characters to move, may be negative
-> m Bool | Returns: whether `iter` moved and is dereferenceable

Moves `count` characters if possible (if `count` would move past the start or end of the buffer, moves to the start or end of the buffer). The return value indicates whether the new position of `iter` is different from its original position, and dereferenceable (the last iterator in the buffer is not dereferenceable). If `count` is 0, the function does nothing and returns `False`.

## forwardCursorPosition

textIterForwardCursorPosition Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> m Bool | Returns: `True` if we moved and the new position is dereferenceable

Moves `iter` forward by a single cursor position. Cursor positions are (unsurprisingly) positions where the cursor can appear. Perhaps surprisingly, there may not be a cursor position between all characters. The most common example for European languages would be a carriage return/newline sequence. For some Unicode characters, the equivalent of say the letter “a” with an accent mark will be represented as two characters, first the letter then a "combining mark" that causes the accent to be rendered; so the cursor can’t go between those two characters. See also the `LogAttr`-struct and `break` function.

## forwardCursorPositions

textIterForwardCursorPositions Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> Int32 | `count`: number of positions to move
-> m Bool | Returns: `True` if we moved and the new position is dereferenceable

Moves up to `count` cursor positions. See `textIterForwardCursorPosition` for details.

## forwardFindChar

textIterForwardFindChar Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> TextCharPredicate | `pred`: a function to be called on each character
-> Maybe TextIter | `limit`: search limit, or `Nothing` for none
-> m Bool | Returns: whether a match was found

Advances `iter`, calling `pred` on each character. If `pred` returns `True`, returns `True` and stops scanning. If `pred` never returns `True`, `iter` is set to `limit` if `limit` is non-`Nothing`, otherwise to the end iterator.

## forwardLine

textIterForwardLine Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> m Bool | Returns: whether `iter` can be dereferenced

Moves `iter` to the start of the next line. If the iter is already on the last line of the buffer, moves the iter to the end of the current line. If after the operation, the iter is at the end of the buffer and not dereferencable, returns `False`. Otherwise, returns `True`.

## forwardLines

textIterForwardLines Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> Int32 | `count`: number of lines to move forward
-> m Bool | Returns: whether `iter` moved and is dereferenceable

Moves `count` lines forward, if possible (if `count` would move past the start or end of the buffer, moves to the start or end of the buffer). The return value indicates whether the iterator moved onto a dereferenceable position; if the iterator didn’t move, or moved onto the end iterator, then `False` is returned. If `count` is 0, the function does nothing and returns `False`. If `count` is negative, moves backward by 0 - `count` lines.

## forwardSearch

textIterForwardSearch Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: start of search
-> Text | `str`: a search string
-> [TextSearchFlags] | `flags`: flags affecting how the search is done
-> Maybe TextIter | `limit`: location of last possible `matchEnd`, or `Nothing` for the end of the buffer
-> m (Bool, TextIter, TextIter) | Returns: whether a match was found

Searches forward for `str`. Any match is returned by setting `matchStart` to the first character of the match and `matchEnd` to the first character after the match. The search will not continue past `limit`. Note that a search is a linear or O(n) operation, so you may wish to use `limit` to avoid locking up your UI on large buffers.

`matchStart` will never be set to a `TextIter` located before `iter`, even if there is a possible `matchEnd` after or at `iter`.

## forwardSentenceEnd

textIterForwardSentenceEnd Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> m Bool | Returns: `True` if `iter` moved and is not the end iterator

Moves forward to the next sentence end. (If `iter` is at the end of a sentence, moves to the next end of sentence.) Sentence boundaries are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango text boundary algorithms).

## forwardSentenceEnds

textIterForwardSentenceEnds Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> Int32 | `count`: number of sentences to move
-> m Bool | Returns: `True` if `iter` moved and is not the end iterator

Calls `textIterForwardSentenceEnd` `count` times (or until `textIterForwardSentenceEnd` returns `False`). If `count` is negative, moves backward instead of forward.

## forwardToEnd

textIterForwardToEnd Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> m () |

Moves `iter` forward to the “end iterator,” which points one past the last valid character in the buffer. `textIterGetChar` called on the end iterator returns 0, which is convenient for writing loops.

## forwardToLineEnd

textIterForwardToLineEnd Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> m Bool | Returns: `True` if we moved and the new location is not the end iterator

Moves the iterator to point to the paragraph delimiter characters, which will be either a newline, a carriage return, a carriage return/newline in sequence, or the Unicode paragraph separator character. If the iterator is already at the paragraph delimiter characters, moves to the paragraph delimiter characters for the next line. If `iter` is on the last line in the buffer, which does not end in paragraph delimiters, moves to the end iterator (end of the last line), and returns `False`.

## forwardToTagToggle

textIterForwardToTagToggle Source #

Arguments

:: (HasCallStack, MonadIO m, IsTextTag a) |
=> TextIter | `iter`: a `TextIter`
-> Maybe a | `tag`: a `TextTag`, or `Nothing`
-> m Bool | Returns: whether we found a tag toggle after `iter`

Moves forward to the next toggle (on or off) of the `TextTag` `tag`, or to the next toggle of any tag if `tag` is `Nothing`. If no matching tag toggles are found, returns `False`, otherwise `True`. Does not return toggles located at `iter`, only toggles after `iter`. Sets `iter` to the location of the toggle, or to the end of the buffer if no toggle is found.

## forwardVisibleCursorPosition

textIterForwardVisibleCursorPosition Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> m Bool | Returns: `True` if we moved and the new position is dereferenceable

Moves `iter` forward to the next visible cursor position. See `textIterForwardCursorPosition` for details.

Since: 2.4

## forwardVisibleCursorPositions

textIterForwardVisibleCursorPositions Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> Int32 | `count`: number of positions to move
-> m Bool | Returns: `True` if we moved and the new position is dereferenceable

Moves up to `count` visible cursor positions. See `textIterForwardCursorPosition` for details.

Since: 2.4

## forwardVisibleLine

textIterForwardVisibleLine Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> m Bool | Returns: whether `iter` can be dereferenced

Moves `iter` to the start of the next visible line. Returns `True` if there was a next line to move to, and `False` if `iter` was simply moved to the end of the buffer and is now not dereferenceable, or if `iter` was already at the end of the buffer.

Since: 2.8

## forwardVisibleLines

textIterForwardVisibleLines Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> Int32 | `count`: number of lines to move forward
-> m Bool | Returns: whether `iter` moved and is dereferenceable

Moves `count` visible lines forward, if possible (if `count` would move past the start or end of the buffer, moves to the start or end of the buffer). The return value indicates whether the iterator moved onto a dereferenceable position; if the iterator didn’t move, or moved onto the end iterator, then `False` is returned. If `count` is 0, the function does nothing and returns `False`. If `count` is negative, moves backward by 0 - `count` lines.

Since: 2.8

## forwardVisibleWordEnd

textIterForwardVisibleWordEnd Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> m Bool | Returns: `True` if `iter` moved and is not the end iterator

Moves forward to the next visible word end. (If `iter` is currently on a word end, moves forward to the next one after that.) Word breaks are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango word break algorithms).

Since: 2.4

## forwardVisibleWordEnds

textIterForwardVisibleWordEnds Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> Int32 | `count`: number of times to move
-> m Bool | Returns: `True` if `iter` moved and is not the end iterator

Calls `textIterForwardVisibleWordEnd` up to `count` times.

Since: 2.4

## forwardWordEnd

textIterForwardWordEnd Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> m Bool | Returns: `True` if `iter` moved and is not the end iterator

Moves forward to the next word end. (If `iter` is currently on a word end, moves forward to the next one after that.) Word breaks are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango word break algorithms).

## forwardWordEnds

textIterForwardWordEnds Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> Int32 | `count`: number of times to move
-> m Bool | Returns: `True` if `iter` moved and is not the end iterator

Calls `textIterForwardWordEnd` up to `count` times.

## free

textIterFree Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a dynamically-allocated iterator
-> m () |

Free an iterator allocated on the heap. This function is intended for use in language bindings, and is not especially useful for applications, because iterators can simply be allocated on the stack.

## getAttributes

textIterGetAttributes Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> m (Bool, TextAttributes) | Returns: `True` if `values` was modified

Computes the effect of any tags applied to this spot in the text. The `values` parameter should be initialized to the default settings you wish to use if no tags are in effect. You’d typically obtain the defaults from `textViewGetDefaultAttributes`.

`textIterGetAttributes` will modify `values`, applying the effects of any tags present at `iter`. If any tags affected `values`, the function returns `True`.

## getBuffer

textIterGetBuffer Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> m TextBuffer | Returns: the buffer

Returns the `TextBuffer` this iterator is associated with.

## getBytesInLine

textIterGetBytesInLine Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> m Int32 | Returns: number of bytes in the line

Returns the number of bytes in the line containing `iter`, including the paragraph delimiters.

## getChar

textIterGetChar Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> m Char | Returns: a Unicode character, or 0 if `iter` is not dereferenceable

The Unicode character at this iterator is returned. (Equivalent to operator* on a C++ iterator.) If the element at this iterator is a non-character element, such as an image embedded in the buffer, the Unicode “unknown” character 0xFFFC is returned. If invoked on the end iterator, zero is returned; zero is not a valid Unicode character. So you can write a loop which ends when `textIterGetChar` returns 0.

## getCharsInLine

textIterGetCharsInLine Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> m Int32 | Returns: number of characters in the line

Returns the number of characters in the line containing `iter`, including the paragraph delimiters.

## getChildAnchor

textIterGetChildAnchor Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> m TextChildAnchor | Returns: the anchor at `iter`

If the location at `iter` contains a child anchor, the anchor is returned (with no new reference count added). Otherwise, `Nothing` is returned.

## getLanguage

textIterGetLanguage Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> m Language | Returns: language in effect at `iter`

A convenience wrapper around `textIterGetAttributes`, which returns the language in effect at `iter`. If no tags affecting language apply to `iter`, the return value is identical to that of `getDefaultLanguage`.

## getLine

textIterGetLine Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> m Int32 | Returns: a line number

Returns the line number containing the iterator. Lines in a `TextBuffer` are numbered beginning with 0 for the first line in the buffer.

## getLineIndex

textIterGetLineIndex Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> m Int32 | Returns: distance from start of line, in bytes

Returns the byte index of the iterator, counting from the start of a newline-terminated line. Remember that `TextBuffer` encodes text in UTF-8, and that characters can require a variable number of bytes to represent.

## getLineOffset

textIterGetLineOffset Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> m Int32 | Returns: offset from start of line

Returns the character offset of the iterator, counting from the start of a newline-terminated line. The first character on the line has offset 0.

## getMarks

textIterGetMarks Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> m [TextMark] | Returns: list of `TextMark`

Returns a list of all `TextMark` at this location. Because marks are not iterable (they don’t take up any "space" in the buffer, they are just marks in between iterable locations), multiple marks can exist in the same place. The returned list is not in any meaningful order.

## getOffset

textIterGetOffset Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> m Int32 | Returns: a character offset

Returns the character offset of an iterator. Each character in a `TextBuffer` has an offset, starting with 0 for the first character in the buffer. Use `textBufferGetIterAtOffset` to convert an offset back into an iterator.

## getPixbuf

textIterGetPixbuf Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> m Pixbuf | Returns: the pixbuf at `iter`

If the element at `iter` is a pixbuf, the pixbuf is returned (with no new reference count added). Otherwise, `Nothing` is returned.

## getSlice

textIterGetSlice Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `start`: iterator at start of a range
-> TextIter | `end`: iterator at end of a range
-> m Text | Returns: slice of text from the buffer

Returns the text in the given range. A “slice” is an array of characters encoded in UTF-8 format, including the Unicode “unknown” character 0xFFFC for iterable non-character elements in the buffer, such as images. Because images are encoded in the slice, byte and character offsets in the returned array will correspond to byte offsets in the text buffer. Note that 0xFFFC can occur in normal text as well, so it is not a reliable indicator that a pixbuf or widget is in the buffer.

## getTags

textIterGetTags Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> m [TextTag] | Returns: list of `TextTag`

Returns a list of tags that apply to `iter`, in ascending order of priority (highest-priority tags are last). The `TextTag` in the list don’t have a reference added, but you have to free the list itself.

## getText

textIterGetText Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `start`: iterator at start of a range
-> TextIter | `end`: iterator at end of a range
-> m Text | Returns: array of characters from the buffer

Returns text in the given range. If the range contains non-text elements such as images, the character and byte offsets in the returned string will not correspond to character and byte offsets in the buffer. If you want offsets to correspond, see `textIterGetSlice`.

## getToggledTags

textIterGetToggledTags Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> Bool | `toggledOn`: `True` to get toggled-on tags
-> m [TextTag] | Returns: tags toggled at this point

Returns a list of `TextTag` that are toggled on or off at this point. (If `toggledOn` is `True`, the list contains tags that are toggled on.) If a tag is toggled on at `iter`, then some non-empty range of characters following `iter` has that tag applied to it. If a tag is toggled off, then some non-empty range following `iter` does not have the tag applied to it.

## getVisibleLineIndex

textIterGetVisibleLineIndex Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> m Int32 | Returns: byte index of `iter` with respect to the start of the line

Returns the number of bytes from the start of the line to the given `iter`, not counting bytes that are invisible due to tags with the “invisible” flag toggled on.

## getVisibleLineOffset

textIterGetVisibleLineOffset Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> m Int32 | Returns: offset in visible characters from the start of the line

Returns the offset in characters from the start of the line to the given `iter`, not counting characters that are invisible due to tags with the “invisible” flag toggled on.

## getVisibleSlice

textIterGetVisibleSlice Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `start`: iterator at start of range
-> TextIter | `end`: iterator at end of range
-> m Text | Returns: slice of text from the buffer

Like `textIterGetSlice`, but invisible text is not included. Invisible text is usually invisible because a `TextTag` with the “invisible” attribute turned on has been applied to it.

## getVisibleText

textIterGetVisibleText Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `start`: iterator at start of range
-> TextIter | `end`: iterator at end of range
-> m Text | Returns: string containing visible text in the range

Like `textIterGetText`, but invisible text is not included. Invisible text is usually invisible because a `TextTag` with the “invisible” attribute turned on has been applied to it.

## hasTag

textIterHasTag Source #

Arguments

:: (HasCallStack, MonadIO m, IsTextTag a) |
=> TextIter | `iter`: an iterator
-> a | `tag`: a `TextTag`
-> m Bool | Returns: whether `iter` is tagged with `tag`

Returns `True` if `iter` points to a character that is part of a range tagged with `tag`. See also `textIterStartsTag` and `textIterEndsTag`.

## inRange

textIterInRange Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> TextIter | `start`: start of range
-> TextIter | `end`: end of range
-> m Bool | Returns: `True` if `iter` is in the range

Checks whether `iter` falls in the range [`start`, `end`). `start` and `end` must be in ascending order.

## insideSentence

textIterInsideSentence Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> m Bool | Returns: `True` if `iter` is inside a sentence.

Determines whether `iter` is inside a sentence (as opposed to in between two sentences, e.g. after a period and before the first letter of the next sentence). Sentence boundaries are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango text boundary algorithms).

## insideWord

textIterInsideWord Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> m Bool | Returns: `True` if `iter` is inside a word

Determines whether the character pointed by `iter` is part of a natural-language word (as opposed to say inside some whitespace). Word breaks are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango word break algorithms).

Note that if `textIterStartsWord` returns `True`, then this function returns `True` too, since `iter` points to the first character of the word.

## isCursorPosition

textIterIsCursorPosition Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> m Bool | Returns: `True` if the cursor can be placed at `iter`

See `textIterForwardCursorPosition` or `LogAttr` or `break` for details on what a cursor position is.

## isEnd

textIterIsEnd Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> m Bool | Returns: whether `iter` is the end iterator

Returns `True` if `iter` is the end iterator, i.e. one past the last dereferenceable iterator in the buffer. `textIterIsEnd` is the most efficient way to check whether an iterator is the end iterator.

## isStart

textIterIsStart Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> m Bool | Returns: whether `iter` is the first in the buffer

Returns `True` if `iter` is the first iterator in the buffer, that is if `iter` has a character offset of 0.

## order

textIterOrder Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `first`: a `TextIter`
-> TextIter | `second`: another `TextIter`
-> m () |

Swaps the value of `first` and `second` if `second` comes before `first` in the buffer. That is, ensures that `first` and `second` are in sequence. Most text buffer functions that take a range call this automatically on your behalf, so there’s no real reason to call it yourself in those cases. There are some exceptions, such as `textIterInRange`, that expect a pre-sorted range.

## setLine

textIterSetLine Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> Int32 | `lineNumber`: line number (counted from 0)
-> m () |

Moves iterator `iter` to the start of the line `lineNumber`. If `lineNumber` is negative or larger than the number of lines in the buffer, moves `iter` to the start of the last line in the buffer.

## setLineIndex

textIterSetLineIndex Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> Int32 | `byteOnLine`: a byte index relative to the start of `iter`’s current line
-> m () |

Same as `textIterSetLineOffset`, but works with a byte index. The given byte index must be at the start of a character, it can’t be in the middle of a UTF-8 encoded character.

## setLineOffset

textIterSetLineOffset Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> Int32 | `charOnLine`: a character offset relative to the start of `iter`’s current line
-> m () |

Moves `iter` within a line, to a new character (not byte) offset. The given character offset must be less than or equal to the number of characters in the line; if equal, `iter` moves to the start of the next line. See `textIterSetLineIndex` if you have a byte index rather than a character offset.

## setOffset

textIterSetOffset Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> Int32 | `charOffset`: a character number
-> m () |

Sets `iter` to point to `charOffset`. `charOffset` counts from the start of the entire text buffer, starting with 0.

## setVisibleLineIndex

textIterSetVisibleLineIndex Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> Int32 | `byteOnLine`: a byte index
-> m () |

Like `textIterSetLineIndex`, but the index is in visible bytes, i.e. text with a tag making it invisible is not counted in the index.

## setVisibleLineOffset

textIterSetVisibleLineOffset Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> Int32 | `charOnLine`: a character offset
-> m () |

Like `textIterSetLineOffset`, but the offset is in visible characters, i.e. text with a tag making it invisible is not counted in the offset.

## startsLine

textIterStartsLine Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: an iterator
-> m Bool | Returns: whether `iter` begins a line

Returns `True` if `iter` begins a paragraph, i.e. if `textIterGetLineOffset` would return 0. However this function is potentially more efficient than `textIterGetLineOffset` because it doesn’t have to compute the offset, it just has to see whether it’s 0.

## startsSentence

textIterStartsSentence Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> m Bool | Returns: `True` if `iter` is at the start of a sentence.

Determines whether `iter` begins a sentence. Sentence boundaries are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango text boundary algorithms).

## startsTag

textIterStartsTag Source #

Arguments

:: (HasCallStack, MonadIO m, IsTextTag a) |
=> TextIter | `iter`: an iterator
-> Maybe a | `tag`: a `TextTag`, or `Nothing`
-> m Bool | Returns: whether `iter` is the start of a range tagged with `tag`

Returns `True` if `tag` is toggled on at exactly this point. If `tag` is `Nothing`, returns `True` if any tag is toggled on at this point.

Note that if `textIterStartsTag` returns `True`, it means that `iter` is at the beginning of the tagged range, and that the character at `iter` is inside the tagged range. In other words, unlike `textIterEndsTag`, if `textIterStartsTag` returns `True`, `textIterHasTag` will also return `True` for the same parameters.

Since: 3.20

## startsWord

textIterStartsWord Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TextIter | `iter`: a `TextIter`
-> m Bool | Returns: `True` if `iter` is at the start of a word

Determines whether `iter` begins a natural-language word. Word breaks are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango word break algorithms).

## togglesTag

textIterTogglesTag Source #

Arguments

:: (HasCallStack, MonadIO m, IsTextTag a) |
=> TextIter | `iter`: an iterator
-> Maybe a | `tag`: a `TextTag`, or `Nothing`
-> m Bool | Returns: whether `tag` is toggled on or off at `iter`

This is equivalent to (`textIterStartsTag` || `textIterEndsTag`), i.e. it tells you whether a range with `tag` applied to it begins or ends at `iter`.